From 721721b8223ff035cf76ddf46dcf08a5354dd068 Mon Sep 17 00:00:00 2001
From: Vincent Bernat <bernat@luffy.cx>
Date: Wed, 29 Jan 2014 09:42:31 +0100
Subject: [PATCH] Use go-bindata from github.com/jteeuwen
Forwarded: https://github.com/inconshreveable/ngrok/pull/85

It is now able to recursively walk into directories and is also able to
generate the debug version of the assets. Therefore, we remove the
manual version of the debug version and use the generated one instead.

The patch has been further modified to use system go-bindata...

diff --git a/Makefile b/Makefile
index 4a5d1d068bdc..b99a5f460422 100644
--- a/Makefile
+++ b/Makefile
@@ -1,9 +1,10 @@
-.PHONY: default server client deps fmt clean all release-client release-server release-all client-assets server-assets
+.PHONY: default server client deps fmt clean all release-all assets client-assets server-assets
 export GOPATH:=$(shell pwd)
 
+BUILDTAGS=debug
 default: all
 
-deps:
+deps: assets
 	go get -tags '$(BUILDTAGS)' -d -v ngrok/...
 
 server: deps
@@ -15,25 +16,25 @@ fmt:
 client: deps
 	go install -tags '$(BUILDTAGS)' ngrok/main/ngrok
 
+assets: client-assets server-assets
+
 client-assets:
-	go get github.com/inconshreveable/go-bindata
-	GOOS="" GOARCH="" go install github.com/inconshreveable/go-bindata
-	bin/go-bindata -o src/ngrok/client/assets assets/client
+	go-bindata -nomemcopy -pkg=assets -tags=$(BUILDTAGS) \
+		-debug=$(if $(findstring debug,$(BUILDTAGS)),true,false) \
+		-o=src/ngrok/client/assets/assets_$(BUILDTAGS).go \
+		assets/client/...
 
 server-assets:
-	go get github.com/inconshreveable/go-bindata
-	GOOS="" GOARCH="" go install github.com/inconshreveable/go-bindata
-	bin/go-bindata -o src/ngrok/server/assets assets/server
-
-release-client: BUILDTAGS=release
-release-client: client-assets client
-
-release-server: BUILDTAGS=release
-release-server: server-assets server
+	go-bindata -nomemcopy -pkg=assets -tags=$(BUILDTAGS) \
+		-debug=$(if $(findstring debug,$(BUILDTAGS)),true,false) \
+		-o=src/ngrok/server/assets/assets_$(BUILDTAGS).go \
+		assets/server/...
 
-release-all: release-client release-server
+release-all: BUILDTAGS=release
+release-all: all
 
 all: fmt client server
 
 clean:
 	go clean -i -r ngrok/...
+	rm -rf src/ngrok/client/assets/ src/ngrok/server/assets/ 
diff --git a/src/ngrok/client/assets/assets_debug.go b/src/ngrok/client/assets/assets_debug.go
deleted file mode 100644
index a7b449cf547d..000000000000
--- a/src/ngrok/client/assets/assets_debug.go
+++ /dev/null
@@ -1,11 +0,0 @@
-// +build !release
-
-package assets
-
-import (
-	"io/ioutil"
-)
-
-func ReadAsset(name string) ([]byte, error) {
-	return ioutil.ReadFile(name)
-}
diff --git a/src/ngrok/client/tls.go b/src/ngrok/client/tls.go
index 12227156ee61..661ff2d0e3b5 100644
--- a/src/ngrok/client/tls.go
+++ b/src/ngrok/client/tls.go
@@ -12,7 +12,7 @@ func LoadTLSConfig(rootCertPaths []string) (*tls.Config, error) {
 	pool := x509.NewCertPool()
 
 	for _, certPath := range rootCertPaths {
-		rootCrt, err := assets.ReadAsset(certPath)
+		rootCrt, err := assets.Asset(certPath)
 		if err != nil {
 			return nil, err
 		}
diff --git a/src/ngrok/client/views/web/http.go b/src/ngrok/client/views/web/http.go
index 79cbba179ce7..61ec3a54b33a 100644
--- a/src/ngrok/client/views/web/http.go
+++ b/src/ngrok/client/views/web/http.go
@@ -241,7 +241,7 @@ func (whv *WebHttpView) register() {
 			}
 		}()
 
-		pageTmpl, err := assets.ReadAsset("assets/client/page.html")
+		pageTmpl, err := assets.Asset("assets/client/page.html")
 		if err != nil {
 			panic(err)
 		}
diff --git a/src/ngrok/client/views/web/view.go b/src/ngrok/client/views/web/view.go
index f4a71b3ebd2f..3eaf34c6f11e 100644
--- a/src/ngrok/client/views/web/view.go
+++ b/src/ngrok/client/views/web/view.go
@@ -56,7 +56,7 @@ func NewWebView(ctl mvc.Controller, addr string) *WebView {
 
 	// serve static assets
 	http.HandleFunc("/static/", func(w http.ResponseWriter, r *http.Request) {
-		buf, err := assets.ReadAsset(path.Join("assets", "client", r.URL.Path[1:]))
+		buf, err := assets.Asset(path.Join("assets", "client", r.URL.Path[1:]))
 		if err != nil {
 			wv.Warn("Error serving static file: %s", err.Error())
 			http.NotFound(w, r)
diff --git a/src/ngrok/server/assets/assets_debug.go b/src/ngrok/server/assets/assets_debug.go
deleted file mode 100644
index a7b449cf547d..000000000000
--- a/src/ngrok/server/assets/assets_debug.go
+++ /dev/null
@@ -1,11 +0,0 @@
-// +build !release
-
-package assets
-
-import (
-	"io/ioutil"
-)
-
-func ReadAsset(name string) ([]byte, error) {
-	return ioutil.ReadFile(name)
-}
diff --git a/src/ngrok/server/tls.go b/src/ngrok/server/tls.go
index 180c97e5ad0e..e59545b3a9bb 100644
--- a/src/ngrok/server/tls.go
+++ b/src/ngrok/server/tls.go
@@ -10,7 +10,7 @@ func LoadTLSConfig(crtPath string, keyPath string) (tlsConfig *tls.Config, err e
 	fileOrAsset := func(path string, default_path string) ([]byte, error) {
 		loadFn := ioutil.ReadFile
 		if path == "" {
-			loadFn = assets.ReadAsset
+			loadFn = assets.Asset
 			path = default_path
 		}
 
-- 
1.9.rc1

